    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ---------------------------------
    028     * StandardXYItemLabelGenerator.java
    029     * ---------------------------------
    030     * (C) Copyright 2001-2005, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id: StandardXYItemLabelGenerator.java,v 1.2.2.1 2005/10/25 20:49:02 mungady Exp $
    036     *
    037     * Changes
    038     * -------
    039     * 13-Dec-2001 : Version 1 (DG);
    040     * 16-Jan-2002 : Completed Javadocs (DG);
    041     * 02-Apr-2002 : Modified to handle null y-values (DG);
    042     * 09-Apr-2002 : Added formatting objects for the x and y values (DG);
    043     * 30-May-2002 : Added series name to standard tool tip (DG);
    044     * 26-Sep-2002 : Fixed errors reported by Checkstyle (DG);
    045     * 23-Mar-2003 : Implemented Serializable (DG);
    046     * 13-Aug-2003 : Implemented Cloneable (DG);
    047     * 17-Nov-2003 : Implemented PublicCloneable (DG);
    048     * 25-Feb-2004 : Renamed XYToolTipGenerator --> XYItemLabelGenerator and
    049     *               StandardXYToolTipGenerator -->
    050     *               StandardXYItemLabelGenerator (DG);
    051     * 26-Feb-2004 : Modified to use MessageFormat (DG);
    052     * 27-Feb-2004 : Added abstract superclass (DG);
    053     * 11-May-2004 : Split into StandardXYToolTipGenerator and
    054     *               StandardXYLabelGenerator (DG);
    055     * 20-Apr-2005 : Renamed StandardXYLabelGenerator
    056     *               --> StandardXYItemLabelGenerator (DG);
    057     *
    058     */
    059
    060    package org.jfree.chart.labels;
    061
    062    import java.io.Serializable;
    063    import java.text.DateFormat;
    064    import java.text.NumberFormat;
    065
    066    import org.jfree.data.xy.XYDataset;
    067    import org.jfree.util.PublicCloneable;
    068
    069    /**
    070     * A standard item label generator for plots that use data from an
    071     * {@link org.jfree.data.xy.XYDataset}.
    072     */
    073    public class StandardXYItemLabelGenerator extends AbstractXYItemLabelGenerator
    074                                              implements XYItemLabelGenerator,
    075                                                         Cloneable,
    076                                                         PublicCloneable,
    077                                                         Serializable {
    078
    079        /** For serialization. */
    080        private static final long serialVersionUID = 7807668053171837925L;
    081
    082        /** The default item label format. */
    083        public static final String DEFAULT_ITEM_LABEL_FORMAT = "{2}";
    084
    085        /**
    086         * Creates an item label generator using default number formatters.
    087         */
    088        public StandardXYItemLabelGenerator() {
    089            this(
    090                DEFAULT_ITEM_LABEL_FORMAT,
    091                NumberFormat.getNumberInstance(), NumberFormat.getNumberInstance()
    092            );
    093        }
    094
    095
    096        /**
    097         * Creates an item label generator using the specified number formatters.
    098         *
    099         * @param formatString  the item label format string (<code>null</code> not
    100         *                      permitted).
    101         * @param xFormat  the format object for the x values (<code>null</code>
    102         *                 not permitted).
    103         * @param yFormat  the format object for the y values (<code>null</code>
    104         *                 not permitted).
    105         */
    106        public StandardXYItemLabelGenerator(String formatString,
    107                                            NumberFormat xFormat,
    108                                            NumberFormat yFormat) {
    109
    110            super(formatString, xFormat, yFormat);
    111
    112        }
    113
    114        /**
    115         * Creates an item label generator using the specified number formatters.
    116         *
    117         * @param formatString  the item label format string (<code>null</code>
    118         *                      not permitted).
    119         * @param xFormat  the format object for the x values (<code>null</code>
    120         *                 not permitted).
    121         * @param yFormat  the format object for the y values (<code>null</code>
    122         *                 not permitted).
    123         */
    124        public StandardXYItemLabelGenerator(String formatString,
    125                                            DateFormat xFormat,
    126                                            NumberFormat yFormat) {
    127
    128            super(formatString, xFormat, yFormat);
    129
    130        }
    131
    132        /**
    133         * Creates a label generator using the specified date formatters.
    134         *
    135         * @param formatString  the label format string (<code>null</code> not
    136         *                      permitted).
    137         * @param xFormat  the format object for the x values (<code>null</code>
    138         *                 not permitted).
    139         * @param yFormat  the format object for the y values (<code>null</code>
    140         *                 not permitted).
    141         */
    142        public StandardXYItemLabelGenerator(String formatString,
    143                                            DateFormat xFormat,
    144                                            DateFormat yFormat) {
    145
    146            super(formatString, xFormat, yFormat);
    147
    148        }
    149
    150        /**
    151         * Generates the item label text for an item in a dataset.
    152         *
    153         * @param dataset  the dataset (<code>null</code> not permitted).
    154         * @param series  the series index (zero-based).
    155         * @param item  the item index (zero-based).
    156         *
    157         * @return The label text (possibly <code>null</code>).
    158         */
    159        public String generateLabel(XYDataset dataset, int series, int item) {
    160            return generateLabelString(dataset, series, item);
    161        }
    162
    163        /**
    164         * Returns an independent copy of the generator.
    165         *
    166         * @return A clone.
    167         *
    168         * @throws CloneNotSupportedException if cloning is not supported.
    169         */
    170        public Object clone() throws CloneNotSupportedException {
    171            return super.clone();
    172        }
    173
    174        /**
    175         * Tests this object for equality with an arbitrary object.
    176         *
    177         * @param obj  the other object (<code>null</code> permitted).
    178         *
    179         * @return A boolean.
    180         */
    181        public boolean equals(Object obj) {
    182            if (obj == this) {
    183                return true;
    184            }
    185            if (obj instanceof StandardXYItemLabelGenerator) {
    186                return super.equals(obj);
    187            }
    188            return false;
    189        }
    190
    191    }